<template>
  <div v-if="!item.hidden">
    <template v-if="hasOneShowingChild(item, item.children) && (!onlyOneChild.children || onlyOneChild.noShowingChildren) && !item.alwaysShow">
      <app-link v-if="onlyOneChild.meta" :to="resolvePath(onlyOneChild.path, onlyOneChild.query)">
        <el-menu-item :index="resolvePath(onlyOneChild.path)" :class="{ 'submenu-title-noDropdown': !isNest }">
          <svg-icon v-if="getIconClass(onlyOneChild)" :icon-class="getIconClass(onlyOneChild)" />
          <template #title>
            <span class="menu-title" :title="hasTitle(onlyOneChild.meta.title)">{{ onlyOneChild.meta.title }}</span>
          </template>
        </el-menu-item>
      </app-link>
    </template>

    <el-sub-menu v-else ref="subMenu" :index="resolvePath(item.path)" teleported>
      <template v-if="item.meta" #title>
        <svg-icon v-if="getIconClass(item)" :icon-class="getIconClass(item)" />
        <span class="menu-title" :title="hasTitle(item.meta?.title)">{{ item.meta?.title }}</span>
      </template>
      <sidebar-item
        v-for="(child, index) in item.children"
        :key="child.path + index"
        :is-nest="true"
        :item="child"
        :base-path="resolvePath(child.path)"
        class="nest-menu"
      />
    </el-sub-menu>
  </div>
</template>

<script setup>
import { isExternal } from '@/utils/validate';
import AppLink from './Link.vue';
import { getNormalPath } from '@/utils/ruoyi';

const rootMenu = inject('rootMenu');
const props = defineProps({
  item: {
    type: Object,
    required: true
  },
  isNest: {
    type: Boolean,
    default: false
  },
  basePath: {
    type: String,
    default: ''
  }
});
const subMenu = ref();
const onlyOneChild = ref({});

const hasOneShowingChild = (parent, children) => {
  if (!children) {
    children = [];
  }
  const showingChildren = children.filter((item) => {
    if (item.hidden) {
      return false;
    } else {
      // Temp set(will be used if only has one showing child)
      onlyOneChild.value = item;
      return true;
    }
  });

  // When there is only one child router, the child router is displayed by default
  if (showingChildren.length === 1) {
    return true;
  }

  // Show parent if there are no child router to display
  if (showingChildren.length === 0) {
    onlyOneChild.value = { ...parent, path: '', noShowingChildren: true };
    return true;
  }

  return false;
};

const resolvePath = (routePath, routeQuery) => {
  if (props.basePath === '/routineCommandMap') {
    return window.location.origin + import.meta.env.VITE_APP_CONTEXT_PATH + '#' + props.basePath;
  }
  if (isExternal(routePath)) {
    return routePath;
  }
  if (isExternal(props.basePath)) {
    return props.basePath;
  }
  if (routeQuery) {
    let query = JSON.parse(routeQuery);
    return { path: getNormalPath(props.basePath + '/' + routePath), query: query };
  }
  return getNormalPath(props.basePath + '/' + routePath);
};

const hasTitle = (title) => {
  if (!title || title.length <= 5) {
    return '';
  }
  return title;
};

const getIconClass = (item) => {
  let res = '';
// || (subMenu.value && !!subMenu.value.opened)
  if (rootMenu.activeIndex === item.path) {
    res = item.meta.icon + 'Active';
  } else if (item.meta && item.meta.icon) {
    res = item.meta.icon;
  }
  return res;
};
</script>

<style lang="scss" scoped>
.el-menu-item.is-active {
  color: #ffffff;
}
.el-sub-menu .el-menu-item.is-active {
  background-color: #2c81ff;
  position: relative;
  &::before {
    content: '';
    width: 4px;
    height: 100%;
    background-color: #fff;
    position: absolute;
    top: 0;
    left: 0;
  }
}

.nest-menu .menu-title {
  margin-left: 10px;
}

.nest-menu .nest-menu .menu-title {
  margin-left: 3px;
}

.nest-menu .nest-menu .nest-menu .menu-title {
  margin-left: -3px;
}

.is-opened {
  :deep(.el-sub-menu__title) {
    color: #fff;
  }
  :deep(.nest-menu) {
    .el-sub-menu__title {
      color: #939faa;
    }
    .is-opened {
      .el-sub-menu__title {
        color: #fff;
      }
      .nest-menu {
        .el-sub-menu__title {
          color: #939faa;
          margin-left: -6px;
        }
        .is-opened {
          .el-sub-menu__title {
            color: #fff;
          }
        }
      }
    }
  }
}
</style>
